#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "trattaMod.h"
#include "ordina.h"

/*
 * trova le modalita' distinte in un insieme di osservazioni
 * di tipo stringa
 * versione con struttura e lettura da file
 * - inizializza nmod a 0
 * - apri il file in lettura
 * - ripeti finche' ci sono osservazioni
 *   - acquisisci osservazione
 *   - cerca se l'osservazione e' uguale a una
 *      delle nmod distinte gia' presenti
 *   - in caso negativo
 *     - se nmod < MAXNMOD
 *       - aggiungi l'osservazione come nuova modalita'
 *       - inizializza la frequenza a 1
 *       - incrementa nmod
 *     - altrimenti comunica problema
 *   - in caso positivo (gia' presente)
 *     - incrementa frequenza
 * - visualizza modalita' distinte e relative frequenze
 * - al termine chiama l'ordinamento e visualizza le modalita' in ordine decrescente
 *   di frequenza, e a parita' di frequenza in ordine alfabetico
 *   (il criterio di ordinamento e' implementato in cfrMod)
 */
int main(int argc, char *argv[]){

  tMod mod[MAXNMOD]; //array delle modalita' distinte
  FILE *fp; 
  Stringa oss;          // osservazione
  int nmod=0;             // numero modalita' distinte
  int nonTrovato, i;
  
  if ((fp=fopen("oss.txt","r"))==NULL){
    printf("Impossibile aprire testo.txt in lettura\n");
    return 1;
  }
  
  while (fscanf(fp,"%s",oss)>0){
        nonTrovato=1;
        for (i=0;i<nmod;i++) // scandisce modalita'
                // e confronta con la nuova oss
            if (strcmp(mod[i].m,oss)==0){
               nonTrovato=0;
               break; // esce dal for- i contiene l'indice
            }
        // l'eventuale break mi manda qui
        if (nonTrovato)
           if (nmod<MAXNMOD) {
             strcpy(mod[nmod].m,oss);
             mod[nmod].f=1; // inizializza frequenza
             nmod++;
           } else printf("impossibile inserire %s per array pieno\n",oss);
        else // ho trovato una modalita' uguale
             // i ne contiene l'indice
             mod[i].f++;
  } // while 
  for (i=0;i<nmod;i++) // visualizzazione
      printf("%s\t f=%d\n",mod[i].m,mod[i].f);
  ordina(mod, nmod);
  printf("Modalita' in ordine decrescente di frequenza\n");
  for (i=0;i<nmod;i++) // visualizzazione
      printf("%s\t f=%d\n",mod[i].m,mod[i].f);
  
  system("PAUSE");	
  return 0;
}
